from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from cStringIO import StringIO
import string
from Products.CMFSpellCheck import CMFSpellCheckTool, spellcheck_globals

def installSubSkin(self, skinFolder, out):
    """ Install a subskin, i.e. a folder/directoryview.
    """
    skinsTool = getToolByName(self, 'portal_skins')

    for skin in skinsTool.getSkinSelections():
        path = skinsTool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if not skinFolder in path:
            try:
                path.insert(path.index('custom')+1, skinFolder)
            except ValueError:
                path.append(skinFolder)
            path = string.join(path, ', ')
            skinsTool.addSkinSelection(skin, path)
            out.write('Subskin %s successfully installed into %s.\n' % (skinFolder, skin))
        else:
            out.write('*** Subskin %s was already installed into %s.\n' % (skinFolder, skin))

def install_actions(self, out):
    at = getToolByName(self, "portal_actions")
    at.manage_aproviders('portal_speller', add_provider=1)
    out.write("Added portal_speller as an action provider at portal_actions.\n")

def setup_skins(self, out):
    skinsTool = getToolByName(self, 'portal_skins')

    if 'cmfspellcheck' not in skinsTool.objectIds():
        addDirectoryViews(skinsTool, 'skins', spellcheck_globals)
        out.write("Added directory views to portal_skins.\n")

    installSubSkin(self, 'cmfspellcheck', out)

def install(self):
    out=StringIO()

    portal = getToolByName(self, 'portal_url').getPortalObject()

    tool = CMFSpellCheckTool.CMFSpellCheckTool()
    portal._setObject(tool.id, tool)
    out.write("Added portal_speller tool.\n")

    setup_skins(self, out)
    install_actions(self, out)

    out.write('Installation completed.\n')
    return out.getvalue()

def uninstall(self):
    out=StringIO()

    at = getToolByName(self, "portal_actions")
    at.manage_aproviders('portal_speller', add_provider=0)
    at.deleteActionProvider('portal_speller')

    out.write("Removed portal_speller from action providers at portal_actions.\n")
    out.write('Uninstallation completed.\n')
    return out.getvalue()
