from Products.CMFSpellCheck.SpellCheckUtility import SpellCheckUtility

from Products.CMFCore.utils import getToolByName
from cStringIO import StringIO
import string

def test(self):
    global out

    # Set global variables
    out = StringIO()
    out.write('*** SpellCheckTest.test called\n\n')

    # Get the portal_spelling tool.
    spellTool = getToolByName(self, 'portal_speller')
    if spellTool is None:
        out.write('Could not get portal_spelling tool!\n')
        return
    else:
        out.write('Got portal_spelling tool\n\n')

    # Display the possible spelling tools.
    spellers = spellTool.getSpellTools()
    for value in spellers:
        out.write('Speller: ' + value + '\n')

    # Display the possible formatting tools.
    formats = spellTool.getFormats()
    for value in formats:
        out.write('Formatter: ' + value + '\n')

    # Set the spelling tool to use.
    spellTool.setCurrentSpeller('aspell')

    # Do a spell check.
    results = spellTool.spellCheck("Now xs the tme to live!\nVatever", self, out)

    # Write results to the StringIO.
    out.write('\nNumber of results: ' + str(len(results)) + '\n')
    for l in results:
        out.write('\nword: ' + l.word + ' line: ' + str(l.line_count) + ' offset: ' + str(l.line_offset) + ' Replacements: ' + str(len(l.replace_values)) + '\n')
        out.write('  Replacement words: ')
        for w in l.replace_values:
            out.write(w + ' ')
        out.write('\n')

    out.write('\nUsing SpellCheckUtility\n')
    speller = SpellCheckUtility("<html><body>Now xs the <!-- comment -->tme to live!\nVatever</body></html>", "html", self, out)
    for l in speller.getMisspelledInfo():
        out.write('\nword: ' + l.word + ' line: ' + str(l.line_count) + ' offset: ' + str(l.line_offset) + ' Replacements: ' + str(len(l.replace_values)) + '\n')
        out.write('  Replacement words: ')
        for w in l.replace_values:
            out.write(w + ' ')
        out.write('\n')

    # Return the StringIO.
    return out.getvalue()
