## Controller Python Script "apply_spellcheck"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=text, id='', wordsreplaced=0
##title=Apply Spell Check
##
from Products.CMFPlone import transaction_note

# This variable is available for reporting
# the number of corrections made
wordsreplaced = int(wordsreplaced)

if wordsreplaced:
    # if there is no id specified, keep the current one
    if not id:
        id = context.getId()

    text_format = getattr(context, 'text_format', '')
    new_context = context.portal_factory.doCreate(context, id)

    kwargs = {'text': text}

    if text_format:
        # Pass thru a text_format since we have it
        kwargs.update({'text_format': text_format})

    new_context.edit(**kwargs)

    transaction_note('Spell check applied to %s at %s' % (
        new_context.title_or_id(),
        new_context.absolute_url()))

    new_context.plone_utils.contentEdit(new_context, id=id)

    message = context.translate(
        msgid='spelling_corrected',
        default='Spelling has been corrected.',
        domain='cmfspellcheck')

    return state.set(
        status='success',
        context=new_context,
        portal_status_message=message)
else:
    message = context.translate(
        msgid='spelling_not_corrected',
        default='Spelling checked but no mistakes corrected.',
        domain='cmfspellcheck')

    return state.set(
        status='failure',
        context=context,
        portal_status_message=message)
